CRYPTO_set_ex_data(3)

NAME
CRYPTO_set_ex_data, CRYPTO_get_ex_data - internal application specific data functions

SYNOPSIS
 #include <openssl/crypto.h>

 int CRYPTO_set_ex_data(CRYPTO_EX_DATA *r, int idx, void *arg);

 void *CRYPTO_get_ex_data(CRYPTO_EX_DATA *r, int idx);

DESCRIPTION
Several OpenSSL structures can have application specific data attached to them. These functions are used internally by OpenSSL to manipulate application specific data attached to a specific structure.

These functions should only be used by applications to manipulate CRYPTO_EX_DATA structures passed to the new_func(), free_func() and dup_func() callbacks: as passed to RSA_get_ex_new_index() for example.

CRYPTO_set_ex_data() is used to set application specific data, the data is supplied in the arg parameter and its precise meaning is up to the application.

CRYPTO_get_ex_data() is used to retrieve application specific data. The data is returned to the application, this will be the same value as supplied to a previous CRYPTO_set_ex_data() call.

RETURN VALUES
CRYPTO_set_ex_data() returns 1 on success or 0 on failure.

CRYPTO_get_ex_data() returns the application data or 0 on failure. 0 may also be valid application data but currently it can only fail if given an invalid idx parameter.

On failure an error code can be obtained from ERR_get_error(3).

SEE ALSO
RSA_get_ex_new_index(3), DSA_get_ex_new_index(3), DH_get_ex_new_index(3)

HISTORY
CRYPTO_set_ex_data() and CRYPTO_get_ex_data() have been available since SSLeay 0.9.0.